package com.logwire.bhft.domain;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 停车场道闸接口信息
 * @TableName t01_interface_parking_gate
 */
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class InterfaceParkingGate implements Serializable {
    /**
     * id
     */
    private Object id;

    /**
     * 请求时间戳
     */
    private Object requestTime;

    /**
     * 请求id
     */
    private String requestId;

    /**
     * 出场请求时间戳
     */
    private Object exitRequestTime;

    /**
     * 出场请求id
     */
    private String exitRequestId;

    /**
     * 车牌号
     */
    private String plateNo;

    /**
     * 设备类型
     */
    private String vehicleType;

    /**
     * 车牌识别信息
     */
    private String plateParseInfo;

    /**
     * 进场时间
     */
    private Object entryTime;

    /**
     * 入口id
     */
    private String entryId;

    /**
     * 出场时间
     */
    private Object exitTime;

    /**
     * 出口id
     */
    private String exitId;

    /**
     * 交易时间
     */
    private Object tradeTime;

    /**
     * 费率版本
     */
    private String tollRateVersion;

    /**
     * 交易类型
     */
    private String tradeType;

    /**
     * 应收费用
     */
    private BigDecimal account;

    /**
     * 现场收取现金
     */
    private BigDecimal cash;

    /**
     * 收费员
     */
    private String tollCollectorName;

    /**
     * 使用类型
     */
    private String useType;

    /**
     * 区域类型
     */
    private String areaId;

    /**
     * 车位id
     */
    private String slotId;

    /**
     * 车位是否预定
     */
    private Boolean booking;

    /**
     * 停车信息详情
     */
    private String parkingDetail;

    /**
     * 出场使用标识
     */
    private String exitFlagNum;

    /**
     * Domain Name
     */
    private String domainName;

    /**
     * version
     */
    private Object version;

    /**
     * deleted
     */
    private Boolean deleted;

    /**
     * Insert User
     */
    private String insertUser;

    /**
     * Insert Date
     */
    private Date insertDate;

    /**
     * Update User
     */
    private String updateUser;

    /**
     * Update Date
     */
    private Date updateDate;

    private static final long serialVersionUID = 1L;

}