package com.logwire.bhft.listener;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.logwire.bhft.domain.Infomation;
import com.logwire.bhft.domain.InterfaceParkingGate;
import com.logwire.bhft.service.ParkingGateService;
import com.rabbitmq.client.Channel;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.math.BigDecimal;

@Component
public class TopicReceiveListener {

    private Logger logger = LoggerFactory.getLogger(TopicReceiveListener.class);

    @Resource
    private ParkingGateService parkingGateService;


    @RabbitListener(queues="queue_topic_ypark2")
    public void receiveMessage(String msg, Channel channel, Message massage){
        System.out.println("接受到信息： " + msg);
        String[] data = msg.split("\\|");

//        System.out.println("接受到信息体： " + data[2]);

        ObjectMapper om = new ObjectMapper();

        try {
            Infomation infomation = om.readValue(data[2], Infomation.class);
            InterfaceParkingGate parkingGate = new InterfaceParkingGate();
//            InterfaceParkingGate interfaceParkingGate = om.readValue(data[2], InterfaceParkingGate.class);
            parkingGate.setAccount(BigDecimal.valueOf(infomation.getAccount()));
            parkingGate.setAreaId(infomation.getAreaId());
            parkingGate.setBooking(infomation.getBooking());
            parkingGate.setCash(BigDecimal.valueOf(infomation.getCash()));
            parkingGate.setDeleted(false);
            parkingGate.setDomainName("interface");
            parkingGate.setEntryId(infomation.getEntryId());
            parkingGate.setExitId(infomation.getExitId());
            parkingGate.setEntryTime(infomation.getEntryTime());
            parkingGate.setExitTime(infomation.getExitTime());
            parkingGate.setPlateNo(infomation.getPlateNo());
            parkingGate.setPlateParseInfo(infomation.getPlateParseInfo());
            parkingGate.setParkingDetail(infomation.getParkingDetail().toString());
            parkingGate.setRequestId(infomation.getRequestId());
            parkingGate.setRequestTime(infomation.getRequestTime());
            parkingGate.setSlotId(infomation.getSlotId());
            parkingGate.setTollRateVersion(infomation.getTollRateVersion());
            parkingGate.setTollCollectorName(infomation.getTollCollectorName());
            parkingGate.setUseType(infomation.getUseType());
            // 出场标识,TODO:需要先判断是否有对应的数值
            parkingGate.setExitFlagNum(infomation.getEntryTime()+infomation.getPlateNo());
//            parkingGate.setVersion(0);
            parkingGate.setVehicleType(infomation.getVehicleType());

            logger.info(infomation.toString());
            logger.info(parkingGate.toString());

            parkingGateService.insertParkingGate(parkingGate);
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }

    }
}
