package com.logwire.bhft.service.impl;

import com.logwire.bhft.dao.InterfaceParkingGateMapper;
import com.logwire.bhft.domain.Infomation;
import com.logwire.bhft.domain.InterfaceParkingGate;
import com.logwire.bhft.service.ParkingGateService;
import com.logwire.bhft.utils.SnowFlake;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Random;

@Service
public class ParkingGateServiceImpl implements ParkingGateService {

    @Resource
    InterfaceParkingGateMapper interfaceParkingGateMapper;

    @Override
    @Transactional
    public InterfaceParkingGate insertParkingGate(InterfaceParkingGate parkingGate) {
        // 根据唯一表示去查询数据库中是否有数据,避免重复消费
        List<InterfaceParkingGate> hasRequestId = interfaceParkingGateMapper.selectAllByRequestIdOrExitRequestId(parkingGate.getRequestId());
        if (hasRequestId.size()>0){
            return null;
        }
        SimpleDateFormat now = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        // 判断是进站还是出站,进站新增,出站修改
        if("".equals(parkingGate.getExitId()) || null == parkingGate.getExitId()){
            // 进站逻辑
            parkingGate.setId(SnowFlake.nextId());
            parkingGate.setVersion(0);
            parkingGate.setInsertUser("interface");
            parkingGate.setInsertDate(new Date());
            int id = interfaceParkingGateMapper.insertAll(parkingGate);
        }else {
            // 出站逻辑
            List<InterfaceParkingGate> interfaceParkingGates = interfaceParkingGateMapper.selectByEntryTimeAndEntryId(parkingGate.getEntryTime(), parkingGate.getEntryId());
            int i = interfaceParkingGateMapper.updateExitInfo(parkingGate);
        }



        parkingGate.setUpdateUser("cjq");
        return null;
    }
}
